%% SatNOGS COMMS - Test Cases
%% Copyright (C) 2023 Libre Space Foundation
%%
%% This work is licensed under a
%% Creative Commons Attribution-ShareAlike 4.0 International License.
%%
%% You should have received a copy of the license along with this
%% work.  If not, see <http://creativecommons.org/licenses/by-sa/4.0/>.

{%- set categories = {
  'Doc-Test': 'DocTest',
  'Interface': 'Interface',
  'Functional': 'Functional',
  'Performance': 'Performance',
  'EMC': 'EMC',
  'Environmental': 'Environmental',
  'E2E': 'EndToEnd',
}
%}

\providecommand{\tightlist}{
\setlength{\itemsep}{0pt}\setlength{\parskip}{0pt}}

{% for category_label, category_command in categories.items() -%}
\newcommand{\{{ category_command }}}{
{% for item in issues if category_label in item.labels and 'Approved' in item.labels %}
  \subsection{{'{' + item.title | md2tex | trim }}}
  \label{subsec:TC-{{item.id}}}
    \subsubsection{Test Case ID}
      \tc{{'{' + item.id | string }}}
    \subsubsection{Description}
      {{ item.content.Description  | re_sub('{{(.*)}}', '\\\setval{\g<1>}') | md2tex | trim  }}
    \subsubsection{Equipment}
      \begin{itemize}
        {% for equipment in item.content.Equipment.split('\n') %}
          \item \equip{{'{' + equipment | replace('*','') | replace('-','') | md2tex | trim  }}}
        {% endfor %}
      \end{itemize}
    \subsubsection{Sequence}
      {{ item.content.Sequence | re_sub('{{(.*)}}', '\\\setval{\g<1>}') | re_sub('#(\d+)', '\\\hyperref[subsec:TC-\g<1>]{TC-\g<1>}') | md2tex | trim  }}
    \subsubsection{Expected Result}
      {{ item.content['Expected Result']  | re_sub('{{(.*)}}', '\\\setval{\g<1>}') | re_sub('#(\d+)', '\\\hyperref[subsec:TC-\g<1>]{TC-\g<1>}') | md2tex | trim  }}
    \subsubsection{Requirements}
      \begin{itemize}
        {% for requirement in item.content.Requirements.split() %}
          {% set req_id = requirement.split('/') %}
          \item \req{{'{' + req_id[8] | trim  }}}
        {% endfor %}
      \end{itemize}
      \newpage
{% endfor %}
}
{% endfor %}
